///////////////////////////////////////////////////////////////////////////////
// 
//  		:	Handbook
//  		:	Handbook.cpp
//  		:	11/04/2007
// 
//  	:	      
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "Handbook.h"

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :       
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CHandbook::CHandbook():CObjectList()
{
	m_pcoliCurrent=NULL;
	

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :     
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CHandbook::~CHandbook()
{
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    Previous
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :         
//                               
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CHandbook::Previous(void)
{
	if (m_pcoliCurrent)
	{
		if (m_pcoliCurrent->GetPrevious()) 
		{
			m_pcoliCurrent=m_pcoliCurrent->GetPrevious();
			m_unPosition--;
		}
	}

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    Next
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :         
//                               
//                                                                       
//                   :     
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CHandbook::Next(void)
{
	if (m_pcoliCurrent)
	{
		if (m_pcoliCurrent->GetNext())
		{
			m_pcoliCurrent=m_pcoliCurrent->GetNext();
			m_unPosition++;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    Add
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    CObject& p_rcoli -  		                               
//                                                                       
//                :      
//                                                                       
//                   :    TRUE -   ,  FALSE 
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CHandbook::Add(CObject& p_rcoli)
{
	CObjectListItem *pcoli;
	unsigned unPosition;
	if (!(CObjectList::Add(p_rcoli,unPosition,pcoli))) return FALSE;
	m_pcoliCurrent=pcoli;
	m_unPosition=unPosition;
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    Remove
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		    
//                                                                       
//                :      . 
//                                                                       
//                   :    TRUE -   ,  FALSE 
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CHandbook::Remove(void)
{
	if (m_pcoliCurrent)
	{
		CObjectListItem *coli=NULL;
		if (m_pcoliCurrent->GetNext()) 
		{
			coli=m_pcoliCurrent->GetNext();
		}
		else 
		{
			if (m_pcoliCurrent->GetPrevious()) 
			{
				coli=m_pcoliCurrent->GetPrevious();
				m_unPosition--;
			}
		}
		if (!this->CObjectList::Remove(*m_pcoliCurrent)) return FALSE;
		m_pcoliCurrent=coli;
	}
	return TRUE;

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    RemoveAll
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :         
//                                                                       
//                   :    TRUE -   ,  FALSE 
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CHandbook::RemoveAll(void)
{
	if (!this->CObjectList::RemoveAll()) return FALSE;
	m_pcoliCurrent=NULL;
	m_unPosition=0;
	return TRUE;

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    FindFirst
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    const wxString& p_rwxstrFindText -   
//                                        
//                             BOOL p_bFindInName -  TRUE,   
//       		                            
//                             BOOL p_bFindInDescription -  TRUE,  
//                                          
//                                             
//                :       ,  
//                                 ( p_bFindInName=TRUE),
//                             /   ( p_bFindInDescription=TRUE)
//                                                                       
//                   :    
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CHandbook::FindFirst(const wxString& p_rwxstrFindText,BOOL p_bFindInName,BOOL p_bFindInDescription)
{
	unsigned unPosition;
	if (p_bFindInName) 
	{
		m_coFind.SetName(p_rwxstrFindText);
	}
	else
	{
		m_coFind.SetName("");
	}
	if (p_bFindInDescription) 
	{
		m_coFind.SetDescription(p_rwxstrFindText);
	}
	else
	{
		m_coFind.SetDescription("");
	}
	m_pcoliCurrent=this->CObjectList::Find(m_pcoliCurrent,m_coFind,unPosition);
	m_unPosition+=unPosition;
	if (!m_pcoliCurrent) 
	{
		m_pcoliCurrent=GetFirstObject();
		m_unPosition=0;
		wxMessageBox(_("Cannot find this string"),_("NO"),wxOK);
	}
}
///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    FindNext
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    		                               
//                                                                       
//                :      ,  
//                              ,     
//                              FindFirst.
//                                                                       
//                   :    
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CHandbook::FindNext()
{
	m_pcoliCurrent=m_pcoliCurrent->GetNext();
	unsigned unPosition=0;
	if (m_pcoliCurrent)
	{
		m_pcoliCurrent=this->CObjectList::Find(m_pcoliCurrent,m_coFind,unPosition);
	}
	if (!m_pcoliCurrent) 
	{
		m_pcoliCurrent=GetFirstObject();
		m_unPosition=0;
	}
	else
	{
		m_unPosition+=unPosition+1;
	}
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    ostream & operator <<
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    ostream & out 
//                             CHandbook& p_chb	- 	                               
//                                                                       
//                :        
//                                                                       
//                   :       
//                                                                       
///////////////////////////////////////////////////////////////////////////////
ostream & operator << (ostream & out, CHandbook& p_chb)
{

	CObjectListItem* pcoliHead=(CObjectListItem* )(p_chb.GetFirstObject());
	out<<p_chb.GetCountObjects()<<'\0';
	while (pcoliHead)
	{
		out<<(*pcoliHead);
		pcoliHead=pcoliHead->GetNext();
	}
	return out;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    ostream & operator >>
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    ostream & in 
//                             CHandbook& p_chb	- 	                               
//                                                                       
//                :        
//                                                                       
//                   :       
//                                                                       
///////////////////////////////////////////////////////////////////////////////
istream & operator >>(istream & in, CHandbook& p_chb)
{
	CObject coBuffer;
	p_chb.RemoveAll();

	unsigned unCount;
	char c;
	in>>unCount>>c;
	for (unsigned n=0; n<unCount;n++)
	{
		in>>coBuffer;
		p_chb.Add(coBuffer);		
	}
	p_chb.m_pcoliCurrent=p_chb.GetFirstObject();
	p_chb.m_unPosition=0;
	
	return in;
}




///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    SetCurrent
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :    CObjectListItem* p_pcoliCurrent  
//                               
//                             unsigned p_unPosituon -                          
//                                                                       
//                :        
//                              .   , 
//                                 .
//                                                                       
//                   :       
//                                                                       
///////////////////////////////////////////////////////////////////////////////
void CHandbook::SetCurrent(CObjectListItem* p_pcoliCurrent, unsigned p_unPosition)
{
	m_pcoliCurrent=p_pcoliCurrent;
	m_unPosition=p_unPosition;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :    GetCurrentPosition
//                   :     Ը                                           
//                    :    23/04/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                      
//                                                                       
//                :       
//                                                                       
//                   :       
//                                                                       
///////////////////////////////////////////////////////////////////////////////
unsigned CHandbook::GetCurrentPosition(void)
{
	return m_unPosition;
}