///////////////////////////////////////////////////////////////////////////////
// 
//      	:  <Handbook>
//  		:  <myapp.cpp>
//  		:  6/03/07
// 
//  	:  <    >
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "myapp.h"
#include "mainframe.h"
#include "data.h"




///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                 :  < >
//                  :                                              
//                    :    6/03/07                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :                                   
//                                                                       
//                :    .    -
//                            
//                                                                       
//                   :  true -  , false -  
//                                                                       
///////////////////////////////////////////////////////////////////////////////

bool CMyApp::OnInit(void)
{
	wxFileConfig *pConfig = new wxFileConfig("Handbook");
    wxConfigBase::Set(pConfig);

	pConfig->SetPath(_T("/Options/"));
	g_nLocale=pConfig->Read(_T("LanguageId"),wxLANGUAGE_DEFAULT);

	g_pLocale=new wxLocale();
    g_pLocale->Init(g_nLocale);
		
	
    // normally this wouldn't be necessary as the catalog files would be found
    // in the default locations, but under Windows then the program is not
    // installed the catalogs are in the parent directory (because the binary
    // is in a subdirectory of samples/internat) where we wouldn't find them by
    // default
    wxLocale::AddCatalogLookupPathPrefix(wxT("."));
    wxLocale::AddCatalogLookupPathPrefix(wxT(".."));
    // Initialize the catalogs we'll be using
    g_pLocale->AddCatalog(wxT("Handbook"));
	g_pLocale->AddCatalog(wxT("wxstd"));

	::wxInitAllImageHandlers();



	 CMainFrame *frame = new CMainFrame(g_wxstrHandbook);

    frame->Show(true);

	frame->GetHelpController().Initialize(_T("Handbook.chm"));
    // success: wxApp::OnRun() will be called which will enter the main message
    // loop and the application will run. If we returned false here, the
    // application would exit immediately.
    return true;
}


//   Application.
IMPLEMENT_APP(CMyApp)
