///////////////////////////////////////////////////////////////////////////////
// 
//        :  Handbook
//        :  object.h
//          :  6/03/07
// 
//      :       CObject,   
//                 ,    
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////


#ifndef _COBJECT_FHOW384S98EGHSO98E4HYSOEB4TGO9S4E
#define _COBJECT_FHOW384S98EGHSO98E4HYSOEB4TGO9S4E

#include <wx/wx.h>
#include <ostream.h>
#include <istream.h>

class CObjectListItem ;

class CObject{
private:
	wxString m_wxstrName;
	wxString m_wxstrDescription;
	wxString m_wxstrImageFileName;
public:


    CObject():m_wxstrName(""),m_wxstrDescription(""),m_wxstrImageFileName("") {}

	CObject(const CObject & p_rco);

	virtual ~CObject() {};

	//   
	wxString GetName(void){return m_wxstrName;}
	void inline SetName(wxString p_wxstrName) {m_wxstrName=p_wxstrName;}

	wxString GetDescription(void){return m_wxstrDescription;}
	void inline SetDescription(wxString p_wxstrDescription) 
		{m_wxstrDescription=p_wxstrDescription;}

	wxString GetImageFileName(void){return m_wxstrImageFileName;}
	void inline SetImageFileName(wxString p_wxstrImageFileName)
		{m_wxstrImageFileName=p_wxstrImageFileName;}

	/////////////////////////////////////////////////////////////////////////////
	// 



	virtual BOOL operator ==(const CObject & p_rco);
	virtual BOOL operator !=(const CObject & p_rco);

	friend ostream & operator << (ostream & out, CObject & p_rco);
	friend istream & operator >> (istream & in, CObject & p_rco);

};
ostream & operator << (ostream & out, CObject & p_rco);
istream & operator >> (istream & in, CObject & p_rco);
#endif