///////////////////////////////////////////////////////////////////////////////
// 
//  		:	Handbook
//  		:	FindDialog.h
//  		:	23/04/2007
// 
//  	:	      
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FindDialog_H__1CC6E6B0_9900_47DC_B874_99D2A5DA20F3__INCLUDED_)
#define AFX_FindDialog_H__1CC6E6B0_9900_47DC_B874_99D2A5DA20F3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CFindDialog : public wxDialog 
{
	wxButton * m_pwxbtnFind,
		     * m_pwxbtnCancel;
	wxTextCtrl * m_pwxtctrlFindText;
	wxCheckBox  * m_pwxcbFindInName,
				* m_pwxcbFindInDescription;

	static wxString m_wxstrFindText;
	BOOL m_bFindInName;
	BOOL m_bFindInDescription;
public:
	CFindDialog(wxWindow * parent, 			
						const wxFont& p_rwxfFont,
						const wxColour& p_rwxcColour,
						const wxColour& p_rwxcBackColour,
						const wxColour& p_rwxcWindowColour);
	virtual ~CFindDialog();


	BOOL GetFindInName() {return m_bFindInName;}
	BOOL GetFindInDescription() {return m_bFindInDescription;}

	void OnFind(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	void OnCancel(wxCommandEvent& WXUNUSED(p_rwxcmdev));
	wxString & GetFindText() {return m_wxstrFindText;};
	DECLARE_EVENT_TABLE()

};


#endif // !defined(AFX_FindDialog_H__1CC6E6B0_9900_47DC_B874_99D2A5DA20F3__INCLUDED_)
