///////////////////////////////////////////////////////////////////////////////
// 
//  		:	Handbook
//  		:	Handbook.h
//  		:	11/04/2007
// 
//  	:	      
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007  Ը 
//
///////////////////////////////////////////////////////////////////////////////


#ifndef _HANDBOOK
#define _HANDBOOK

#include "objectlist.h"
#include <ostream.h>
class CHandbook:public CObjectList
{
	CObjectListItem *m_pcoliCurrent;
	CObject m_coFind;
	unsigned m_unPosition;
public:
	CHandbook();
	virtual ~CHandbook();



	BOOL Add(CObject& p_rcoli);
	BOOL Remove();
	BOOL RemoveAll();
	const CObjectListItem * GetCurrent();
	unsigned  GetCurrentPosition();
	void SetCurrent(CObjectListItem* p_pcoliCurrent,unsigned p_unPosition); 
	wxString GetName(void);
	wxString GetDescription(void);
	wxString GetImageFileName(void);
	BOOL SetName(wxString p_wxstrName);
	BOOL  SetDescription(wxString p_wxstrDescription);
	BOOL SetImageFileName(wxString p_wxstrImageFileName);
	BOOL IsFree(){if (!m_pcoliCurrent) return TRUE; else return FALSE;}
	void Previous(void);
	void Next(void);

	void FindFirst(const wxString& p_rwxstrFindText,BOOL p_bFindInName, BOOL p_bFindInDescription);
	void FindNext();
	friend ostream & operator << (ostream & out,  CHandbook& p_chb);
	friend istream & operator >> (istream & in,  CHandbook& p_chb);
};

extern ostream & operator << (ostream & out,  CHandbook& p_chb);
extern istream & operator >> (istream & in,  CHandbook& p_chb);

inline wxString CHandbook::GetName(void )
{
	if (m_pcoliCurrent) return m_pcoliCurrent->GetName();
	return wxString("");
}

inline wxString  CHandbook::GetDescription()
{
	if (m_pcoliCurrent) return m_pcoliCurrent->GetDescription();
	else return wxString("");
}

inline BOOL  CHandbook::SetName(wxString p_wxstrName)
{
	if (m_pcoliCurrent)
	{
		m_pcoliCurrent->SetName(p_wxstrName);
		return TRUE;
	}
	return FALSE;
}

inline BOOL  CHandbook::SetDescription(wxString p_wxstrDescription)
{
	if (m_pcoliCurrent) 
	{
		m_pcoliCurrent->SetDescription(p_wxstrDescription);
		return TRUE;
	}
	else return FALSE;
}

inline const CObjectListItem * CHandbook::GetCurrent()
{
	return m_pcoliCurrent;
}

inline  wxString CHandbook::GetImageFileName(void)
{
	if (m_pcoliCurrent)	return m_pcoliCurrent->GetImageFileName();
	else return wxString("");
}

inline BOOL CHandbook::SetImageFileName(wxString p_wxstrImageFileName)
{
	if (m_pcoliCurrent) 
	{
		m_pcoliCurrent->SetImageFileName(p_wxstrImageFileName);
		return TRUE;
	}
	else return FALSE;

}
#endif