///////////////////////////////////////////////////////////////////////////////
// 
//      	:  Handbook
//  		:  object.cpp
//  		:  6/03/2007
// 
//  	:    object.
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "object.h"
#include "objectlistitem.h"
///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  
//                   :   Ը 
//                    :  6/03/2007                                 
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  const CObject& p_rco                               
//                                                                       
//                :                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
CObject::CObject(const CObject & p_rco)
{
	memcpy((void*)this, (const void*)&p_rco,sizeof(p_rco));
}



///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  ostream & operator <<
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  ostream & out, CObject& p_rco                 
//                                                                       
//                :                          
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
ostream & operator << (ostream & out, CObject & p_rco)
{
	out<<p_rco.m_wxstrName<<'\0';
	out<<p_rco.m_wxstrDescription<<'\0';
	out<<p_rco.m_wxstrImageFileName<<'\0';
	return out;
}


///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  istream& operator >>
//                   :   Ը 
//                    :  6/03/2007                                  
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  istream & in, CObject & p_rco                              
//                                                                       
//                :     .                      
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
 istream & operator >> (istream & in, CObject & p_rco)
{
	ReadString(in,p_rco.m_wxstrName);
	ReadString(in,p_rco.m_wxstrDescription);
	ReadString(in,p_rco.m_wxstrImageFileName);
	return in;
}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  operator ==
//                   :   Ը 
//                    :  6/03/2007                                 
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  const CObject& p_rco                               
//                                                                       
//                :                      
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObject::operator ==(const CObject & p_rco)
{
	if (m_wxstrName!=p_rco.m_wxstrName) return FALSE;
	if (m_wxstrDescription!=p_rco.m_wxstrDescription) return FALSE;
	if (m_wxstrImageFileName!=p_rco.m_wxstrImageFileName) return FALSE;
	return TRUE;

}

///////////////////////////////////////////////////////////////////////////////
//                                                                       
//                   :  operator !=
//                   :   Ը 
//                    :  6/03/2007                                 
//                                                                         
//-----------------------------------------------------------------------------
//                                                                       
//               :  const CObject& p_rco                               
//                                                                       
//                :                       
//                                                                       
//                   :  
//                                                                       
///////////////////////////////////////////////////////////////////////////////
BOOL CObject::operator !=(const CObject & p_rco)
{
	if (m_wxstrName!=p_rco.m_wxstrName) return TRUE;
	if (m_wxstrDescription!=p_rco.m_wxstrDescription) return TRUE;
	if (m_wxstrImageFileName!=p_rco.m_wxstrImageFileName) return TRUE;
	return FALSE;
}

