///////////////////////////////////////////////////////////////////////////////
// 
//        :  Handbook
//        :  objectlistitem.h
//          :  7/03/07
// 
//      :       CObjectListItem, 
//                  
// 
///////////////////////////////////////////////////////////////////////////////
//
//    COPYRIGHT (c)  2007.  Ը 
//
///////////////////////////////////////////////////////////////////////////////

#include "object.h"


#ifndef _OBJECTLISTITEM
#define _OBJECTLISTITEM

class CObjectListItem:public CObject
{
protected:
	CObjectListItem * m_pcoliPrevious;
	CObjectListItem * m_pcoliNext;
public:
	CObjectListItem():m_pcoliPrevious(NULL),m_pcoliNext(NULL){}
	CObjectListItem(CObject& p_rco);
	virtual ~CObjectListItem();

	//   
	CObjectListItem * GetPrevious()		{return m_pcoliPrevious;}
	CObjectListItem * GetNext()  		{return m_pcoliNext;}

	//  
	BOOL AddBefore(CObject & p_rco);
	BOOL AddAfter(CObject & p_rco);

	

	// 
	virtual const CObjectListItem & operator = (CObjectListItem & p_rcoliObjectListItem);
	virtual const CObjectListItem & operator = (CObject & p_rcoObject);
};




#endif